use ovlach_pdf::rocket_builder;
use rocket::launch;


use opentelemetry::trace::TracerProvider as _;
use opentelemetry_sdk::trace::TracerProvider;
use opentelemetry_stdout as stdout;
use tracing::{error, span};
use tracing_subscriber::{layer::SubscriberExt, util::SubscriberInitExt};
use tracing_subscriber::Registry;


use opentelemetry::{
    metrics::MeterProvider as _,
    trace::{Tracer, TracerProvider as _},
    KeyValue,
};
use opentelemetry_sdk::{
    metrics::{PeriodicReader, MeterProvider},
    runtime,
};


fn init_meterprovider() -> MeterProvider {
    let exporter = opentelemetry_stdout::MetricsExporter::default();
    let reader = PeriodicReader::builder(exporter, runtime::Tokio).build();
    MeterProvider::builder().with_reader(reader).build()
}



#[rocket::main]
async fn main() {
    let logger = opentelemetry_stdout::SpanExporter::default();
    let provider = TracerProvider::builder()
        .with_simple_exporter(logger)
        .build();

        let telemetry = tracing_opentelemetry::layer().with_tracer(provider.tracer("default"));
        let meter_provider = init_meterprovider();
    Registry::default().with(telemetry).init();
    let _ = rocket_builder().launch().await;
}